//	16x2 LCDW[
//	SC1602BSLB
//  (4bitڑ)
//	D4	: CN3-7	: P3-0
//	D5	: CN3-8	: P3-1
//	D6	: CN3-9	: P3-2
//	D7	: CN3-10: P3-3
//	RS	: CN3-11: P3-4
//	E	: CN3-12: P3-5
//
//  H}U[̏ꍇR/WLOŒȂ̂WRITEIy[VłȂ
#include <300H/3048S.H>
#include <sysio.h>
#include "mb_test.h"
#include "LCD.h"

#define D(a)	P3.DR.BYTE = ((P3.DR.BYTE & 0xF0) | (a & 0x0F))
#define RS		P3.DR.BIT.B4
#define E		P3.DR.BIT.B5

// o^L (5x8hbg̃LN^8o^ł̂œKɍĂ܂)
const char g_pData[8][8] = {
{	0x0A,		// 01010
	0x1F,		// 11111
	0x1F,		// 11111
	0x1F,		// 11111
	0x1F,		// 11111
	0x0E,		// 01110
	0x0E,		// 01110
	0x04		// 00100
},
{	0x04,		// 00100
	0x0E,		// 01110
	0x0E,		// 01110
	0x1F,		// 11111
	0x1F,		// 11111
	0x0E,		// 01110
	0x0E,		// 01110
	0x04		// 00100
},
{	0x04,		// 00100
	0x0E,		// 01110
	0x1F,		// 11111
	0x1F,		// 11111
	0x1F,		// 11111
	0x15,		// 10101
	0x0E,		// 01110
	0x0E		// 01110
},
{	0x04,		// 00100
	0x0E,		// 01110
	0x1F,		// 11111
	0x0E,		// 01110
	0x15,		// 10101
	0x1F,		// 11111
	0x0E,		// 01110
	0x04		// 00100
},
{	0x0E,		// 01110
	0x1F,		// 11111
	0x1F,		// 11111
	0x1F,		// 11111
	0x1F,		// 11111
	0x1F,		// 11111
	0x1F,		// 11111
	0x0E		// 01110
},
{	0x0E,		// 01110
	0x11,		// 10001
	0x15,		// 10101
	0x15,		// 10101
	0x15,		// 10101
	0x15,		// 10101
	0x11,		// 10001
	0x0E		// 01110
},
{	0x0E,		// 01110
	0x11,		// 10001
	0x11,		// 10001
	0x11,		// 10001
	0x11,		// 10001
	0x11,		// 10001
	0x11,		// 10001
	0x0E		// 01110
},
{	0x0E,		// 01110
	0x1F,		// 11111
	0x1F,		// 11111
	0x1F,		// 11111
	0x0E,		// 01110
	0x15,		// 10101
	0x15,		// 10101
	0x1F		// 11111
}};

static void lcd_init(char cData);			// LCDp]
static void lcd_write(char cData, int nRS);	// LCDփf[^]

void InitLCD()
{
	int i;

	P3.DDR = 0x3F;		// E,RS,D4`7 o̓|[g
	P3.DR.BYTE = 0;

	wait_ms(15);		// dON15ms̃C^[o
	lcd_init(0x03);
	lcd_init(0x03);
	lcd_init(0x03);
	lcd_init(0x02);
	lcd_write(0x28, 0);	// Function Set  (4bit[h)
	lcd_write(0x0E, 0);	// Display On/Off Control
	lcd_write(0x06, 0);	// Entry Mode Set
	lcd_write(0x01, 0);	// Clear Display

	for(i=0; i<8; i++){
		LCD_CGRAM(i, g_pData[i]);	// ftHgLN^o^
	}
}

void LCD_Clear()
{
	lcd_write(0x01, 0);	// Clear Display
}

void LCD_Home()
{
	lcd_write(0x02, 0);	// Cursor At Home
}

// nInc		: 0=CNg, 1=fNg
// nShift	: 1=Display shift
void LCD_EntryMode(int nInc, int nShift)
{
	char cData = 0x04 | ((nInc << 1) & 0x02) | (nShift & 0x01);
	lcd_write(cData, 0);	// Entry Mode Set
}

// nDisp	: Display On/Off
// nCursor	: Cursor On/Off
// nBlink	: Blink of cursor position character
void LCD_DisplayControl(int nDisp, int nCursor, int nBlink)
{
	char cData = 0x08 | ((nDisp << 2) & 0x04) | ((nCursor << 1) & 0x02) | (nBlink & 0x01);
	lcd_write(cData, 0);	// Display On/Off Control
}

// nShift	: 1=Display shift, 0=Cursor movement
// nRight	: 1=Shift to the right, 0=Shift to the left
void LCD_CousorShift(int nShift, int nRight)
{
	char cData = 0x10 | ((nShift << 3) & 0x08) | ((nRight << 2) & 0x04);
	lcd_write(cData, 0);	// Cousor/Display Shift
}

void LCD_Locate(int x, int y)
{
	int nX = x;
	int nY = (y >= 0)&&(y <= 1) ? y : 0;
	char cData = 0x80 | (unsigned char)((nY * 0x40) + nX); 
	lcd_write(cData, 0);	// DDRAM Address Set
}

void LCD_PrintChar(char cData)
{
	lcd_write(cData, 1);	// CGRAM/DDRAM Data Write
}

void LCD_Print(char* pszData, int nLen)
{
	int i;
	for(i=0; i<nLen; i++){
		LCD_PrintChar(pszData[i]);
	}
}

// nIdx		: 0`7 ܂łCGRAMCfbNX
// pData	: char[8]CGf[^ (eoCg̉5rbgsNZf[^A3rbg͖)
void LCD_CGRAM(int nIdx, char* pData)
{
	int i;
	char cAddr = (char)(nIdx * 8);
	LCD_CGRAMAddr(cAddr);
	for(i=0; i<8; i++){
		LCD_PrintChar(pData[i]);
	}
}

void LCD_CGRAMAddr(char cAddr)
{
	char cData = 0x40 | (cAddr & 0x3F);
	lcd_write(cData, 0);	// CGRAM Address Set
}

void LCD_Out(char cData)
{
	lcd_write(cData, 0);
}

// LCDp]
//	cData	: D4`D74Bitf[^
void lcd_init(char cData)
{
	RS = 0;
	E = 1;
	D(cData);
	wait_1ms();			// قƂ40sł񂾂
	E = 0;
	wait_ms(4);
}

// LCDփf[^]
//	cData	: D0`D78Bitf[^
//	nRS		: RSrbg
void lcd_write(char cData, int nRS)
{
	RS = nRS;
	E = 1;
	D(cData>>4);
	wait_1ms();			// قƂ40sł񂾂
	E = 0;
	wait_1ms();			// قƂ40sł񂾂

	E = 1;
	D(cData);
	wait_1ms();			// قƂ40sł񂾂
	E = 0;
	wait_1ms();			// قƂ40sł񂾂
}
