#include "stdafx.h"
#include "mb_test.h"
#include "mb_testDlg.h"
#include "common.h"

// VA|[g̗
//	arr	: "COM1", "COM2"AꂽVA|[gi[
//
void FindComm(CStringArray &arr)
{
	HKEY hKey;
	DWORD dwIndex = 0;
	char* pszValueName;
	DWORD dwValueNameSize;
	DWORD dwValueType;
	char* pszValue;
	DWORD dwValueSize;

	char szClass[256];
	DWORD dwClassSize;
	DWORD dwSubKeys, dwMaxSubKey, dwMaxClass, dwValue, dwMaxValueName, dwMaxValueData, dwSecurityDescriptor;
	FILETIME ftLastTime;

	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, "HARDWARE\\DEVICEMAP\\SERIALCOMM", 0, KEY_READ, &hKey) == ERROR_SUCCESS){
		// |[g擾
		dwClassSize = 256;
		if(RegQueryInfoKey(hKey, szClass, &dwClassSize, NULL, &dwSubKeys, &dwMaxSubKey, &dwMaxClass, &dwValue, &dwMaxValueName, &dwMaxValueData, &dwSecurityDescriptor, &ftLastTime) == ERROR_SUCCESS){
			pszValueName = new char[dwMaxValueName + 1];
			pszValue = new char[dwMaxValueData + 1];
			while(1){
				dwValueNameSize = dwMaxValueName + 1;
				dwValueSize = dwMaxValueData + 1;
				if(RegEnumValue(hKey, dwIndex, pszValueName, &dwValueNameSize, NULL, &dwValueType, (LPBYTE)pszValue, &dwValueSize) != ERROR_SUCCESS){
					break;
				}
				if(dwValueType == REG_SZ){
					if(dwIndex == 0) arr.RemoveAll();
					arr.Add(pszValue);
				}
				dwIndex++;
			}
			delete[] pszValueName;
			delete[] pszValue;
		}
	}
}

//
// R~jP[VNX
//

CComm::CComm()
{
	m_strPort = "";
	m_pWnd = NULL;
	m_bOpen = FALSE;
	m_hPort = NULL;
	m_pThreadProc = NULL;
	m_hExitEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	m_psz2ndBuf = NULL;
	m_dw2ndBufIdx = 0;
	m_dw2ndBufSize = 0;

	m_hMutex = CreateMutex(NULL, FALSE, NULL);
	m_bSTX = FALSE;
	m_dwSTX = 0;

	m_cSW = m_cDIP = 0;
}

CComm::CComm(CWnd* pWnd, CString &strPort)
{
	m_strPort = "";
	m_pWnd = NULL;
	m_bOpen = FALSE;
	m_hPort = NULL;
	m_pThreadProc = NULL;
	m_hExitEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	m_psz2ndBuf = NULL;
	m_dw2ndBufIdx = 0;
	m_dw2ndBufSize = 0;

	m_hMutex = CreateMutex(NULL, FALSE, NULL);
	m_bSTX = FALSE;
	m_dwSTX = 0;

	Open(pWnd, strPort);
}

CComm::~CComm()
{
	Close();
	if(m_hExitEvent != NULL){
		CloseHandle(m_hExitEvent);
		m_hExitEvent = NULL;
	}
	if(m_hMutex != NULL){
		CloseHandle(m_hMutex);
		m_hMutex = NULL;
	}
}

BOOL CComm::Open(CWnd* pWnd, CString &strPort)
{
	DWORD dwError;

	m_strPort = strPort;
	m_pWnd = pWnd;
	m_bSTX = FALSE;
	m_dwSTX = 0;

	// Ƀ|[gI[vĂꍇ̓N[Y
	if(m_bOpen){
		Close();
	}
	// |[gI[v
	CString strPortLong = "\\\\.\\" + strPort;
	m_hPort = CreateFile((LPCSTR)strPortLong, GENERIC_READ|GENERIC_WRITE, 0, NULL,
			OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL);
	if(m_hPort == INVALID_HANDLE_VALUE){
		dwError = GetLastError();
		m_hPort = NULL;
	}else{
		COMMCONFIG ccf;
		DWORD dw = sizeof(ccf);
		ZeroMemory(&ccf, sizeof(ccf));
		ccf.dwSize = sizeof(ccf);
		ccf.wVersion = 1;
		GetDefaultCommConfig((LPCSTR)strPort,&ccf,&dw);
		ccf.dcb.BaudRate = 19200;				// {[[gݒ (38400)
		ccf.dcb.ByteSize = 8;					// f[^rbg (8rbg)
		ccf.dcb.Parity = NOPARITY;				// peB (Ȃ)
		ccf.dcb.StopBits = ONESTOPBIT;			// Xgbvrbg (1rbg)
		// t[Ȃ
		ccf.dcb.fOutxCtsFlow = FALSE;
		ccf.dcb.fOutxDsrFlow = FALSE;
		ccf.dcb.fDtrControl = FALSE;
		ccf.dcb.fDsrSensitivity = FALSE;
		ccf.dcb.fTXContinueOnXoff = FALSE;
		ccf.dcb.fOutX = FALSE;
		ccf.dcb.fInX = FALSE;
		ccf.dcb.fRtsControl = FALSE;
		if(SetCommConfig(m_hPort, &ccf, dw)){
			PurgeComm(m_hPort, PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
			COMMPROP cp;
			if(GetCommProperties(m_hPort, &cp)){
				// MpXbhN
				if((m_pThreadProc = AfxBeginThread(CComm::ReadProc, this)) != NULL){
					m_bOpen = TRUE;
					Sleep(100);
				}
			}
		}
	}
	if(!m_bOpen){
		Close();
	}
	return m_bOpen;
}

void CComm::Close()
{
	// MXbhI
	if(m_pThreadProc != NULL){
		SetEvent(m_hExitEvent);
		if(WaitForSingleObject(m_pThreadProc->m_hThread, 3000) == WAIT_TIMEOUT){	// ő3bԏI҂
			TerminateThread(m_pThreadProc->m_hThread, -1);
		}
		m_pThreadProc = NULL;
	}

	// |[gN[Y
	if(m_hPort != NULL){
		PurgeComm(m_hPort, PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
		CloseHandle(m_hPort);
		m_hPort = NULL;
	}
	m_bOpen = FALSE;

	// 2ndobt@NA
	if(m_psz2ndBuf != NULL){
		delete[] m_psz2ndBuf;
		m_psz2ndBuf = NULL;
		m_dw2ndBufIdx = 0;
		m_dw2ndBufSize = 0;
	}
}

// f[^M
//	szBuf	: Mf[^
//	dwSize	: Mf[^TCY
//	bWait	: TRUE=M܂ŃubN
//	߂l	: ̏ꍇTRUE, Mُ܂̓^CAEgFALSE
//
//	memo : ^CAEg͌Œ3b
//
BOOL CComm::Write(const char* szBuf, DWORD dwSize, BOOL bWait)
{
	BOOL bRet = FALSE;
	LPOVERLAPPED pOver = NULL;
	DWORD dwSendRet;

#ifdef _DEBUG
TRACE("--> ");
DWORD dwCnt = 0;
char szTrace[101];
for(DWORD t=0; t<dwSize; t+=100){
	strncpy_s(szTrace, 101, &szBuf[t], 100);
	szTrace[100] = '\0';
	TRACE("%s", szTrace);
	dwCnt += 100;
}
if(dwCnt < dwSize){
	strcpy_s(szTrace, 101, &szBuf[dwCnt]);
	TRACE("%s", szTrace);
}
TRACE("\n");
#endif

	if(m_hPort == NULL)
		return FALSE;

	if(bWait){
		pOver = new OVERLAPPED;
		ZeroMemory(pOver, sizeof(OVERLAPPED));
		pOver->hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	}

	dwSendRet = 0;
	bRet = WriteFile(m_hPort, szBuf, dwSize, &dwSendRet, pOver);
	DWORD dwLastErr = GetLastError();
	if(bRet || (!bRet && (dwLastErr == ERROR_IO_PENDING))){
		if((!bRet)&&(pOver != NULL)){
			if(WaitForSingleObject(pOver->hEvent, 3000) == WAIT_OBJECT_0){
				bRet = TRUE;
			}
		}
	}
	if(pOver != NULL){
		CloseHandle(pOver->hEvent);
		delete pOver;
	}
	return bRet;
}


// MpXbh
//	߂l	: 0
UINT CComm::ReadProc(LPVOID pParam)
{
	CComm* pThis = (CComm*)pParam;
	UINT nRet = 0;
	BOOL bResult;
	char szRecvBuf[MSG_BUFFER*2];
	DWORD dwRecvRet;
	DWORD dwLastErr;
	HANDLE hWaits[2];
	DWORD dwWaitRet;
	OVERLAPPED ovRead;

	ZeroMemory(&ovRead, sizeof(ovRead));
	ovRead.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	while(1){
		BOOL bExit = FALSE;
		dwRecvRet = 0;
		bResult = ReadFile(pThis->m_hPort, szRecvBuf, MSG_BUFFER, &dwRecvRet, &ovRead);
		dwLastErr = GetLastError();
		if(bResult || (!bResult && (dwLastErr == ERROR_IO_PENDING))){
			if(!bResult){
				// M҂
				hWaits[0] = pThis->m_hExitEvent;
				hWaits[1] = ovRead.hEvent;
				dwWaitRet = WaitForMultipleObjects(2, hWaits, FALSE, INFINITE);
				switch(dwWaitRet){
				case WAIT_OBJECT_0:			// ICxg
					bExit = TRUE;
					break;
				case (WAIT_OBJECT_0+1):		// Ǎ
					if(GetOverlappedResult(pThis->m_hExitEvent, &ovRead, &dwRecvRet, TRUE)){
						bResult = TRUE;
					}
					ResetEvent(ovRead.hEvent);
					break;
				}
			}
			if(bExit)
				break;
			if(bResult){
				// f[^Ǎ
#ifdef _DEBUG
static int nCount = 0;
nCount++;
if(nCount >= 100){
	TRACE("*");
	nCount = 0;
}
//TRACE("%c", szRecvBuf[0]);
#endif
				pThis->Analysis(szRecvBuf, dwRecvRet);
			}
		}
		// I`FbN
		if(WaitForSingleObject(pThis->m_hExitEvent, 0) == WAIT_OBJECT_0){
			break;
		}
	}
	CloseHandle(ovRead.hEvent);
	return nRet;
}

// Mf[^ (ebZ[Wɕ)
//	szBuf	: new Mf[^
//	dwSize	: szBufTCY
//
void CComm::Analysis(const char* szBuf, DWORD dwSize)
{
	char* pszNewBuf;
	DWORD dwNewSize;
	char* pszCopyIndex;
	DWORD dwStartIdx = m_dw2ndBufIdx;

	// 2ndobt@փf[^ǉ
	dwNewSize = dwSize + m_dw2ndBufIdx;
	if(m_dw2ndBufSize < dwNewSize){
		m_dw2ndBufSize = dwNewSize + 2048;
		pszNewBuf = new char[m_dw2ndBufSize];
		if(m_psz2ndBuf != NULL){
			CopyMemory(pszNewBuf, m_psz2ndBuf, m_dw2ndBufIdx);
			delete[] m_psz2ndBuf;
			pszCopyIndex = pszNewBuf + m_dw2ndBufIdx;
		}else{
			pszCopyIndex = pszNewBuf;
		}
		m_psz2ndBuf = pszNewBuf;
	}else{
		pszCopyIndex = m_psz2ndBuf + m_dw2ndBufIdx;
	}
	CopyMemory(pszCopyIndex, szBuf, dwSize);
	m_dw2ndBufIdx += dwSize;

	// Mf[^(2ndobt@)
	DWORD dwLostIndex = 0;
	for(DWORD i=dwStartIdx; i<dwNewSize; i++){
		if(m_psz2ndBuf[i] == STX){
			m_bSTX = TRUE;
			m_dwSTX = i;
		}else if(m_bSTX){
			if(m_psz2ndBuf[i] == ETX){
#ifdef _DEBUG
//CString strCommand = CString(&m_psz2ndBuf[m_dwSTX+1], i-m_dwSTX-1);
//TRACE("\n<-- %s\n", (const char*)strCommand);
TRACE("\n<-- ");
DWORD dwLen = i-m_dwSTX-1;
char *pszTrace = new char[dwLen+1];
strncpy_s(pszTrace, dwLen+1, &m_psz2ndBuf[m_dwSTX+1], dwLen);
pszTrace[dwLen] = '\0';
DWORD dwCnt = 0;
char szTrace[101];
for(DWORD t=0; t<dwLen; t+=100){
	strncpy_s(szTrace, 101, &pszTrace[t], 100);
	szTrace[100] = '\0';
	TRACE("%s", szTrace);
	dwCnt += 100;
}
if(dwCnt < dwLen){
	strcpy_s(szTrace, 101, &pszTrace[dwCnt]);
	TRACE("%s", szTrace);
}
delete[] pszTrace;
TRACE("\n");
#endif
				CommandSwitch(&m_psz2ndBuf[m_dwSTX+1], i-m_dwSTX-1);
				dwLostIndex = i;
				m_bSTX = FALSE;
				m_dwSTX = 0;
				break;
			}
		}
	}

	// 2ndobt@菈ς݃f[^폜
	if(dwLostIndex > 0){
		if((dwNewSize = m_dw2ndBufSize - (dwLostIndex + 1)) > 0){
			pszNewBuf = new char[dwNewSize];
			CopyMemory(pszNewBuf, m_psz2ndBuf + (dwLostIndex + 1), dwNewSize);
			delete[] m_psz2ndBuf;
			m_psz2ndBuf = pszNewBuf;
			m_dw2ndBufIdx -= m_dw2ndBufSize - dwNewSize;
			m_dw2ndBufSize = dwNewSize;
TRACE("buffer=%d\n", m_dw2ndBufSize);
		}else if(dwNewSize == 0){
			delete[] m_psz2ndBuf;
			m_psz2ndBuf = NULL;
			m_dw2ndBufIdx = 0;
			m_dw2ndBufSize = 0;
TRACE("buffer=delete\n");
		}
	}
}

// R}hbZ[W
//	szBuf	: R}hbZ[W (STX,ETX)
//	dwSize	: szBuf̃TCY
//
void CComm::CommandSwitch(const char* szBuf, DWORD dwSize)
{
	char szCommand[4];
	int nCommand;

	WaitForSingleObject(m_hMutex, INFINITE);

	if(dwSize <= 4) return;
	if(szBuf[0] != 'C') return;

	CopyMemory(szCommand, &szBuf[1], 3);
	szCommand[3] = '\0';
	sscanf_s(szCommand, "%d", &nCommand);
	switch(nCommand){
	case 1:		// LCDNA
		Recv001(szBuf, dwSize);
		break;
	case 2:		// LCDJ[\z[
		Recv002(szBuf, dwSize);
		break;
	case 3:		// LCDGg[h
		Recv003(szBuf, dwSize);
		break;
	case 4:		// LCDfBXvC
		Recv004(szBuf, dwSize);
		break;
	case 5:		// LCDJ[\
		Recv005(szBuf, dwSize);
		break;
	case 6:		// LCD CGRAM Address Set
		Recv006(szBuf, dwSize);
		break;
	case 7:		// LCD DDRAM Address Set
		Recv007(szBuf, dwSize);
		break;
	case 8:		// LCD CGRAM/DDRAM Data Write
		Recv008(szBuf, dwSize);
		break;
	case 11:	// LED_/
		Recv011(szBuf, dwSize);
		break;
	case 21:	// ^NgSWԕ
		Recv021(szBuf, dwSize);
		break;
	case 22:	// fBbvSWԕ
		Recv022(szBuf, dwSize);
		break;
	case 23:	// fBbvSWԊmF
		Recv023(szBuf, dwSize);
		break;
	}
	ReleaseMutex(m_hMutex);
}

void CComm::Send001()
{
	char szMsg[256];
	wsprintf(szMsg, "%c%4s%c", STX, "H001", ETX);
	Write(szMsg, 6, TRUE);
}

void CComm::Send002()
{
	char szMsg[256];
	wsprintf(szMsg, "%c%4s%c", STX, "H002", ETX);
	Write(szMsg, 6, TRUE);
}

void CComm::Send003(char cData)
{
	char szMsg[256];
	cData = 0x04 | (cData & 0x3);
	wsprintf(szMsg, "%c%4s%1X%c", STX, "H003", cData, ETX);
	Write(szMsg, 7, TRUE);
}

void CComm::Send004(char cData)
{
	char szMsg[256];
	cData = 0x08 | (cData & 0x7);
	wsprintf(szMsg, "%c%4s%1X%c", STX, "H004", cData, ETX);
	Write(szMsg, 7, TRUE);
}

void CComm::Send005(char cData)
{
	char szMsg[256];
	cData = 0x10 | (cData & 0xF);
	wsprintf(szMsg, "%c%4s%02X%c", STX, "H005", cData, ETX);
	Write(szMsg, 8, TRUE);
}

void CComm::Send006(char cData)
{
	char szMsg[256];
	cData = 0x20 | (cData & 0x1F);
	wsprintf(szMsg, "%c%4s%02X%c", STX, "H006", cData, ETX);
	Write(szMsg, 8, TRUE);
}

void CComm::Send007(char cData)
{
	char szMsg[256];
	cData = 0x40 | (cData & 0x3F);
	wsprintf(szMsg, "%c%4s%02X%c", STX, "H007", cData, ETX);
	Write(szMsg, 8, TRUE);
}

void CComm::Send008(char cData)
{
	char szMsg[256];
	cData = 0x80 | (cData & 0x7F);
	wsprintf(szMsg, "%c%4s%02X%c", STX, "H008", (unsigned char)cData, ETX);
	Write(szMsg, 8, TRUE);
}

void CComm::Send009(char *pszData, int nLen)
{
	char szMsg[256];
	int nIdx = 0;
	szMsg[nIdx] = STX;
	nIdx++;
	wsprintf(&szMsg[nIdx], "%s%02X", "H009", nLen);
	nIdx += 6;
	for(int i=0; i<nLen; i++){
		wsprintf(&szMsg[nIdx], "%02X", (unsigned char)pszData[i]);
		nIdx += 2;
	}
	szMsg[nIdx] = ETX;
	nIdx++;
	szMsg[nIdx] = '\0';
	Write(szMsg, nIdx, TRUE);
}

void CComm::Send011(char cData)
{
	char szMsg[256];
	wsprintf(szMsg, "%c%4s%1X%c", STX, "H011", cData, ETX);
	Write(szMsg, 7, TRUE);
}

void CComm::Send021()
{
	char szMsg[256];
	wsprintf(szMsg, "%c%4s%c", STX, "H021", ETX);
	Write(szMsg, 6, TRUE);
}

void CComm::Send022()
{
	char szMsg[256];
	wsprintf(szMsg, "%c%4s%c", STX, "H022", ETX);
	Write(szMsg, 6, TRUE);
}

void CComm::Send023()
{
	char szMsg[256];
	wsprintf(szMsg, "%c%4s%c", STX, "H023", ETX);
	Write(szMsg, 6, TRUE);
}

void CComm::Recv001(const char* szBuf, DWORD dwSize)
{
}

void CComm::Recv002(const char* szBuf, DWORD dwSize)
{
}

void CComm::Recv003(const char* szBuf, DWORD dwSize)
{
}

void CComm::Recv004(const char* szBuf, DWORD dwSize)
{
}

void CComm::Recv005(const char* szBuf, DWORD dwSize)
{
}

void CComm::Recv006(const char* szBuf, DWORD dwSize)
{
}

void CComm::Recv007(const char* szBuf, DWORD dwSize)
{
}

void CComm::Recv008(const char* szBuf, DWORD dwSize)
{
}

void CComm::Recv009(const char* szBuf, DWORD dwSize)
{
}

void CComm::Recv011(const char* szBuf, DWORD dwSize)
{
}

void CComm::Recv021(const char* szBuf, DWORD dwSize)
{
	char szFld[5];
	int nData;
	WPARAM wParam;
	strncpy_s(szFld, 5, &szBuf[4], 1); szFld[1] = '\0';
	sscanf_s(szFld, "%X", &nData);
	m_cSW = (BYTE)nData & 0x0F;
	wParam = MAKEWPARAM(MAKEWORD(m_cDIP, m_cSW), 0);
	m_pWnd->PostMessage(WM_USER_KEY, wParam);
}

void CComm::Recv022(const char* szBuf, DWORD dwSize)
{
	char szFld[5];
	int nData;
	WPARAM wParam;
	strncpy_s(szFld, 5, &szBuf[4], 2); szFld[2] = '\0';
	sscanf_s(szFld, "%X", &nData);
	m_cDIP = (BYTE)nData;
	wParam = MAKEWPARAM(MAKEWORD(m_cDIP, m_cSW), 0);
	m_pWnd->PostMessage(WM_USER_KEY, wParam);
}

void CComm::Recv023(const char* szBuf, DWORD dwSize)
{
	char szFld[5];
	int nData;
	WPARAM wParam;
	strncpy_s(szFld, 5, &szBuf[4], 1); szFld[1] = '\0';
	sscanf_s(szFld, "%X", &nData);
	m_cSW = (BYTE)nData & 0x0F;
	strncpy_s(szFld, 5, &szBuf[5], 2); szFld[2] = '\0';
	sscanf_s(szFld, "%X", &nData);
	m_cDIP = (BYTE)nData;
	wParam = MAKEWPARAM(MAKEWORD(m_cDIP, m_cSW), 0);
	m_pWnd->PostMessage(WM_USER_KEY, wParam);
}
